import Test.QuickCheck

squares :: [Int] -> [Int]
squares xs  =  [ x*x | x <- xs ]

squaresRec :: [Int] -> [Int]
squaresRec []      =  []
squaresRec (x:xs)  =  x*x : squaresRec xs

squaresCond :: [Int] -> [Int]
squaresCond ws  =
  if null ws then
    []
  else
    let
      x  = head ws
      xs = tail ws
    in
      x*x : squaresCond xs

prop_squares :: [Int] -> Bool
prop_squares xs  =   squares xs == squaresRec xs
                  && squares xs == squaresCond xs
