import Test.QuickCheck

squares :: [Integer] -> [Integer]
squares xs  =  [ x*x | x <- xs ]

odds :: [Integer] -> [Integer]
odds xs  =  [ x | x <- xs, odd x ]

sumSqOdd :: [Integer] -> Integer
sumSqOdd xs  =  sum [ x*x | x <- xs, odd x ]

sumSqOddRec :: [Integer] -> Integer
sumSqOddRec []                  =  0
sumSqOddRec (x:xs) | odd x      =  x*x + sumSqOddRec xs
                   | otherwise  =  sumSqOddRec xs

sumSqOddComp :: [Integer] -> Integer
sumSqOddComp xs  =  sum (squares (odds xs))

prop_sumSqOdd :: [Integer] -> Bool
prop_sumSqOdd xs  =  sumSqOdd xs == sumSqOddComp xs &&
                     sumSqOdd xs == sumSqOddRec xs

